#include <vector>
#include <iostream>

using namespace std;

const int N = 1e6, A = 239017;

// N=random[n..2n] 
vector<int> h1[N]; // списочная/цепочечная
void add1(int x) { h1[x % N].push_back(x); }

// N*0.7
// открытая адресация
int h[N]; // N=random[n..2n] 
int index(int64_t x) { // O(1)
	// int i = ((int64_t)A * x) % N; // hash-function
	int i = x % N; // hash-function
	while (h[i] != 0 && h[i] != x)
		i = (i + A) % N; // линейное хеширование
		// i = (i + (x << 10) + A) % N; // двойное хеширование
	return i;
}
// x=0,1,2,3,4,5,6,7,8,... N/4
// x=random(),random()     N/4

int main() {
	
}